package main

import (
	"fmt"
	"sort"
)

//Função pra efitar problemas com string que é uma constante
func PróximoInput() (s string) {
	fmt.Scanf("%s", &s)
	return
}

func main() {
	Entr, Card := CarregaDados()
	sort.Sort(ByPlaca(Entr))
	sort.Sort(ByCódigo(Card))
	//Cria Cliente
	var (
		cliente Cliente //Cliente
		cli Clientes
		i int = 0
		j int = 0
		controle int
		total float64
		)
	//Estabelido um limite de clientes pois causa menos efeitos colaterais
	cli = make(Clientes, 100, 100)
	for {
		G9: //Bloco G9
		controle = 0
		total = 0.0
		fmt.Println("\nTelefone (0 para sair)")
		s := PróximoInput()
		if s == "0" {
			break
		} 
		if s != "0" {
			cliente.Telefone = s
		}
		// Bloco G1
		G1:
		fmt.Println("\nCliente já cadastrado? ([s]im ou [n]ão)")
			s = PróximoInput()
		//Bloco G2
		G2:
		if s == "s" || s == "S" {
				for _, v := range cli {
					if v.Telefone == cliente.Telefone {
						controle = 1
						fmt.Println("\nCliente cadastrado:")
						controle = 7
						goto G3
					}		
				}
				if controle == 0 {
					fmt.Println("\nNão existe registro de seu telefone no sistema. Escolha [n]ão")
					goto G1
				}	
			}	else if s == "n" || s == "N" {
					for _, v := range cli {
						if v.Telefone == cliente.Telefone {
							fmt.Println("\nEste telefone já existe no sistema. Escolha [s]im")
							goto G1 //Vai para o label G1
						}			
					}
					fmt.Println("\nCliente não cadastrado. Novo cadastro:")
					controle = 2
					goto G4
				}	else {
						fmt.Println("\nDigite [s]im ou [n]ão.")
						goto G1 //Vai para o label G1
					}
		//Bloco G3
		G3:				
		if controle == 7 {			
			fmt.Println("\n",cliente.Nome,", [C]onfirma ou [R]ecadastrar?")
			s = PróximoInput()
			controle = 6
			goto G8
		}
		//Bloco G4
		G4:
		if controle == 2 {
			fmt.Println("\nNome:")
			s = PróximoInput()
			cliente.Nome = s
			fmt.Println("\nEndereço:")
			s = PróximoInput()
			cliente.Endereço = s
			fmt.Println("\nPonto de Referência:")
			s = PróximoInput()
			cliente.Referência = s
			cli[i] = cliente
			i++
			s = "s"
			goto G2
		}
		//Bloco G5
		G5: 
		fmt.Println("\nCódigo		Item 		Preço\n")
		if controle == 3 {
			for _, v := range Card {
			fmt.Println(v.Código,"	",v.Item,"	",v.Preço)
			}
			controle = 6
			s = "c"
			goto G8 //Bloco G8
		}
		//Bloco G6
		G6:
		if controle == 4 {
			fmt.Println("\nTotal: R$",total,",Confirma? ([s]im ou [n]ão)")
			s = PróximoInput()
			if s == "s" || s == "S" {
				Entr[j].Total += total
				Entr[j].Quantidade++
				j++
				fmt.Println("\nPedido processado.")
				goto G9
			}	else if s == "N" || s == "n" {
					fmt.Println("\nPedido cancelado.")
					goto G9
				}	else {
						fmt.Println("\nFavor responda [s]im ou [n]ão")
						controle = 4
						goto G6
					}
		}
		//Bloco G7
		G7:
		if controle == 5 {
			for _, v := range Card {
				if v.Código == parseInt(s) {
					fmt.Println("\nAdicionado", v.Item,"ao pedido.\nQuantidade:")
					s = PróximoInput()
					f := parseFloat(s)
					if(j < len(Entr)) {
						total += v.Preço*f
						s = "c"
						controle = 6
						goto G8
					}	else {
							j = 0
							total += v.Preço*f
							s = "c"
							controle = 6
							goto G8
						}
				}

			}
			fmt.Println("\nNão há item com o código",s,"no cardápio")
			s = "c"
			controle = 6 
			goto G8
		}
		//Bloco G8
		G8:
		if controle == 6 { 
			if s == "c" || s == "C" {
				fmt.Println("\nAdicionar item (? para cardapio, 0 para finaliza):")
				s = PróximoInput()
				if s == "?" {
					controle = 3
					fmt.Println("\nCardápio:")
					goto G5 //Bloco G5
					}	else if s == "0" {
						controle = 4
						goto G6
						}	else  if s != "0" && s!= "?" {
								controle = 5
								goto G7 //Bloco G7	
							} 
			}	else if s == "r" || s == "R"{
					fmt.Println("\nRecadastrando cliente")
					controle = 2
					goto G4
					}	else {
							fmt.Println("\nResponda: [C]onfirma ou [R]ecadastrar?")
							controle = 7
							goto G3
							}
		}		
	} //fim do for
	//Relatório
	fmt.Println("\nEntregador; Quantidade de Entregas; Valor Total; Comissão\n")
	for _, v := range Entr {
		fmt.Println(v.Nome," ",v.Quantidade,"	R$:",v.Total,"	R$:",v.Total*0.05)
	}
}
